#ifndef _NANDDRIVER_H_
#define _NANDDRIVER_H_

#include <nds.h>

#ifdef __cplusplus
extern "C" {
#endif

bool ndInitNAND();

// ߼/ӳ
void ndBuildLUT();

// ߼ֵַַ
// oldPhyAddress Ϊ NULLʾдҪ oldPhyAddress 
// ʹ߿Բ Ϊ FREE  oldPhyAddress ڵ block
// logicBlock [out]  oldPhyAddress ڿʵfreeblockʱ򣬴
// תõ logicBlock ţԱԺдʱԸfreeblockһ

u32 ndLog2Phy( u32 logicAddress, u32 * oldPhyAddress );

// ָ zone Ѱ freeblockֵΧ 0 - 1023
u16 ndSearchFreeBlock( u8 zone, bool markFreeBlkToCfg );

// ݣaddr ֵ ĩ 9 λ0, addr  LBA
void ndReadPages( u32 addr, u32 pageCount, u8 * buffer );

// дݣaddr ֵ ĩ 9 λ0, addr  LBA
void ndWritePages( u32 addr, u32 pageCount, const u8 * data );

// дݣaddr ֵ ĩ 9 λ0, addr  LBAдδɵblock
void ndWritePagesSafe( u32 addr, u32 pageCount, const u8 * data );

// ִ nand ڲ Page Copy һдʱ򣬰old blockݿfree block
// pageCount ָжٸ512 page
// startSubPage ָӵһ2k pageĸ512k pageʼ
// ڶ block ֮俽 64  page
// srcAddr  destAddr Ӧö
void ndNandMove( u32 srcAddr, u32 destAddr, u8 pageCount );

//  ڲ PageCopy ޷ʹõʱֶsrcַʼ 528 Ϊλ page destַ
// pageCount ָжٸ512 page
// startSubPage ָӵһ2k pageĸ512k pageʼ
// ڶ block ֮俽 64 2kpage512Ҳպ256
void ndCopyPages( u32 srcAddr, u32 destAddr, u8 pageCount );

//  ڲ PageCopy ޷ʹõʱֶsrcַʼ 528 Ϊλ page destַ
// pageCount ָжٸ512 page
// startSubPage ָӵһ2k pageĸ512k pageʼ
// ڶ block ֮俽 64 2kpage512Ҳպ256
void ndCopyPages2K( u32 srcAddr, u32 destAddr, u8 pageCount );

// βǽϴεWriteβWrite(Read)
// ôִndFinishPartialCopyѸղŰƵǸblockĺ벿ݿµblock
void ndFinishPartialCopy();

/*

*/
void ndReplaceBlock( u32 oldBlockAddr );

// дǷ ecc 
//  ecc ˵ɿܲȶ
// ôndReplaceBlock()Ѿɿ鿽¿飬ɿΪ飬д 2 bit ecc error
// ô¼ǸpageeccѴŴд¿飬ⶪʧ
// ֵ 0  no error
//          1  1 bit ecc error
//          2  2 bit ecc error
bool ndCheckError();
/*

*/

#ifdef __cplusplus
}
#endif

#endif//_NANDDRIVER_H_
